from contextlib import contextmanager
import logging
import sys


logger = logging.getLogger(__name__)


@contextmanager
def hidden_traceback():
    """
    Prints uncaught exception traceback with 0 limit.
    """
    def handle_exception(exctype, value, tb):
        logger.error(u"Unexpected error occurred: {0}".format(value))

    sys.excepthook = handle_exception
    yield
    sys.excepthook = sys.__excepthook__
