# coding: utf-8

import os
import locale
from gettext import translation

from tionix_client.settings import BASE_DIR

APP_NAME = "tionix_client"

LOCALE_DIR = os.path.join(BASE_DIR, 'locale')

LANGUAGES = os.environ.get('LANG', '').split(':')
LANGUAGES.append('en_US')

lc, encoding = locale.getdefaultlocale()
if lc:
    LANGUAGES.append(lc)

t = translation(APP_NAME, LOCALE_DIR, set(LANGUAGES), fallback=True)


def ugettext(msg):
    new_msg = t.gettext(msg)
    if isinstance(new_msg, str):
        return new_msg.decode('utf-8')
    return new_msg
