# coding: utf-8

from urllib import urlencode

import six

from novaclient import base


class JournalResource(base.Resource):
    HUMAN_ID = True

    _module_name = 'tnx_journal'
    _version = None


class JournalManager(base.ManagerWithFind):
    resource_class = JournalResource
    alias = 'tnx-journal'

    # pylint: disable=arguments-differ
    def list(self, user_id=None, instance_id=None, limit=None, offset=None,
             search_opts=None):

        qparams = {}

        if search_opts is None:
            search_opts = {}

        for opt, val in six.iteritems(search_opts):
            if val:
                if isinstance(val, six.text_type):
                    val = val.encode('utf-8')
                qparams[opt] = val

        if user_id:
            qparams['user_id'] = user_id
        if instance_id:
            qparams['instance_id'] = instance_id
        if limit:
            qparams['limit'] = limit
        if offset:
            qparams['offset'] = offset

        return self._list(
            '/{0}{1}'.format(
                self.alias,
                '?{0}'.format(urlencode(qparams, doseq=True))), 'journal')


class JournalClientExtension(object):
    name = 'tnx_journal'
    manager_class = JournalManager
