# coding: utf-8

from urllib import urlencode

import six

from novaclient import base


class NodeJournalResource(base.Resource):
    HUMAN_ID = True

    _module_name = 'tnx_node_journal'
    _version = None


class NodeJournalManager(base.ManagerWithFind):
    resource_class = NodeJournalResource
    alias = 'tnx-node-journal'

    # pylint: disable=arguments-differ
    def list(self, user_id=None, node_id=None, limit=None, offset=None,
             search_opts=None):

        qparams = {}

        if search_opts is None:
            search_opts = {}

        for opt, val in six.iteritems(search_opts):
            if val:
                if isinstance(val, six.text_type):
                    val = val.encode('utf-8')
                qparams[opt] = val

        if user_id:
            qparams['user_id'] = user_id
        if node_id:
            qparams['node_id'] = node_id
        if limit:
            qparams['limit'] = limit
        if offset:
            qparams['offset'] = offset

        return self._list(
            '/{0}{1}'.format(
                self.alias,
                '?{0}'.format(urlencode(qparams, doseq=True))), 'journal')


class NodeJournalClientExtension(object):
    name = 'tnx_node_journal'
    manager_class = NodeJournalManager
